org.scalatest.concurrent

# ConductorMethods

#### trait ConductorMethods extends AbstractSuite

Trait that provides each test with access to a new `Conductor` via methods.

Here's an example of the use of this trait to test the `ArrayBlockingQueue` concurrency abstraction from `java.util.concurrent`:

    import org.scalatest.FunSuite
    import org.scalatest.concurrent.ConductorMethods
    import org.scalatest.matchers.ShouldMatchers
    import java.util.concurrent.ArrayBlockingQueue

    class ArrayBlockingQueueSuite extends FunSuite with ConductorMethods with ShouldMatchers {

      test("calling put on a full queue blocks the producer thread") {

        val buf = new ArrayBlockingQueue[Int](1)

        thread("producer") {
          buf put 42
          buf put 17
          beat should be (1)
        }

        thread("consumer") {
          waitForBeat(1)
          buf.take should be (42)
          buf.take should be (17)
        }

        whenFinished {
          buf should be ('empty)
        }
      }

      test("calling take on an empty queue blocks the consumer thread") {

        val buf = new ArrayBlockingQueue[Int](1)

        thread("producer") {
          waitForBeat(1)
          buf put 42
          buf put 17
        }

        thread("consumer") {
          buf.take should be (42)
          buf.take should be (17)
          beat should be (1)
        }

        whenFinished {
          buf should be ('empty)
        }
      }
    }

For an explanation of how these tests work, see the documentation for `Conductor`.

Self Type
  ConductorMethods with Suite

Linear Supertypes
AbstractSuite, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. ConductorMethods
2. AbstractSuite
3. AnyRef
4. Any

Visibility

1. Public
2. All

### Abstract Value Members

1. #### def expectedTestCount (filter: Filter): Int

   The total number of tests that are expected to run when this `Suite`'s `run` method is invoked.

   The total number of tests that are expected to run when this `Suite`'s `run` method is invoked.

   filter

     a `Filter` with which to filter tests to count based on their tags

   Attributes
     abstract
   Definition Classes
     AbstractSuite

2. #### def nestedSuites : List[Suite]

   A `List` of this `Suite` object's nested `Suite`s.

   A `List` of this `Suite` object's nested `Suite`s. If this `Suite` contains no nested `Suite`s, this method returns an empty `List`.

   Attributes
     abstract
   Definition Classes
     AbstractSuite

3. #### def run (testName: Option[String], reporter: Reporter, stopper: Stopper, filter: Filter, configMap: Map[String, Any], distributor: Option[Distributor], tracker: Tracker): Unit

   Runs this suite of tests.

   Runs this suite of tests.

   testName

     an optional name of one test to execute. If `None`, all relevant tests should be executed. I.e., `None` acts like a wildcard that means execute all relevant tests in this `Suite`.

   reporter

     the `Reporter` to which results will be reported

   stopper

     the `Stopper` that will be consulted to determine whether to stop execution early.

   filter

     a `Filter` with which to filter tests based on their tags

   configMap

     a `Map` of key-value pairs that can be used by the executing `Suite` of tests.

   distributor

     an optional `Distributor`, into which to put nested `Suite`s to be executed by another entity, such as concurrently by a pool of threads. If `None`, nested `Suite`s will be executed sequentially.

   tracker

     a `Tracker` tracking `Ordinal`s being fired by the current thread.

   Attributes
     abstract
   Definition Classes
     AbstractSuite

4. #### def runNestedSuites (reporter: Reporter, stopper: Stopper, filter: Filter, configMap: Map[String, Any], distributor: Option[Distributor], tracker: Tracker): Unit

   Runs zero to many of this suite's nested suites.

   Runs zero to many of this suite's nested suites.

   reporter

     the `Reporter` to which results will be reported

   stopper

     the `Stopper` that will be consulted to determine whether to stop execution early.

   filter

     a `Filter` with which to filter tests based on their tags

   configMap

     a `Map` of key-value pairs that can be used by the executing `Suite` of tests.

   distributor

     an optional `Distributor`, into which to put nested `Suite`s to be run by another entity, such as concurrently by a pool of threads. If `None`, nested `Suite`s will be run sequentially.

   tracker

     a `Tracker` tracking `Ordinal`s being fired by the current thread.

   Attributes
     protected abstract
   Definition Classes
     AbstractSuite

5. #### def runTest (testName: String, reporter: Reporter, stopper: Stopper, configMap: Map[String, Any], tracker: Tracker): Unit

   Runs a test.

   Runs a test.

   testName

     the name of one test to execute.

   reporter

     the `Reporter` to which results will be reported

   stopper

     the `Stopper` that will be consulted to determine whether to stop execution early.

   configMap

     a `Map` of key-value pairs that can be used by the executing `Suite` of tests.

   tracker

     a `Tracker` tracking `Ordinal`s being fired by the current thread.

   Attributes
     protected abstract
   Definition Classes
     AbstractSuite

6. #### def runTests (testName: Option[String], reporter: Reporter, stopper: Stopper, filter: Filter, configMap: Map[String, Any], distributor: Option[Distributor], tracker: Tracker): Unit

   Runs zero to many of this suite's tests.

   Runs zero to many of this suite's tests.

   testName

     an optional name of one test to run. If `None`, all relevant tests should be run. I.e., `None` acts like a wildcard that means run all relevant tests in this `Suite`.

   reporter

     the `Reporter` to which results will be reported

   stopper

     the `Stopper` that will be consulted to determine whether to stop execution early.

   filter

     a `Filter` with which to filter tests based on their tags

   configMap

     a `Map` of key-value pairs that can be used by the executing `Suite` of tests.

   distributor

     an optional `Distributor`, into which instances of this `Suite` class that are responsible for executing individual tests contained in this Suite, or groups of this `Suite`'s tests, may be placed so as to be run by another entity, such as concurrently by a pool of threads.

   tracker

     a `Tracker` tracking `Ordinal`s being fired by the current thread.

   Attributes
     protected abstract
   Definition Classes
     AbstractSuite

7. #### def tags : Map[String, Set[String]]

   A `Map` whose keys are `String` tag names with which tests in this `Suite` are marked, and whose values are the `Set` of test names marked with each tag.

   A `Map` whose keys are `String` tag names with which tests in this `Suite` are marked, and whose values are the `Set` of test names marked with each tag. If this `Suite` contains no tags, this method returns an empty `Map`.

   Subclasses may implement this method to define and/or discover tags in a custom manner, but overriding method implementations should never return an empty `Set` as a value. If a tag has no tests, its name should not appear as a key in the returned `Map`.

   Attributes
     abstract
   Definition Classes
     AbstractSuite

8. #### def testNames : Set[String]

   An `Set` of test names.

   An `Set` of test names. If this `Suite` contains no tests, this method returns an empty `Set`.

   Although subclass and subtrait implementations of this method may return a `Set` whose iterator produces `String` test names in a well-defined order, the contract of this method does not required a defined order. Subclasses are free to implement this method and return test names in either a defined or undefined order.

   Attributes
     abstract
   Definition Classes
     AbstractSuite

### Concrete Value Members

1. #### def != (arg0: AnyRef): Boolean

   Attributes
     final
   Definition Classes
     AnyRef

2. #### def != (arg0: Any): Boolean

   Attributes
     final
   Definition Classes
     Any

3. #### def ## (): Int

   Attributes
     final
   Definition Classes
     AnyRef → Any

4. #### def == (arg0: AnyRef): Boolean

   Attributes
     final
   Definition Classes
     AnyRef

5. #### def == (arg0: Any): Boolean

   Attributes
     final
   Definition Classes
     Any

6. #### def asInstanceOf [T0] : T0

   Attributes
     final
   Definition Classes
     Any

7. #### def beat : Int

   Gets the current value of the clock.

   Gets the current value of the clock. Primarily useful in assert statements.

   returns

     the current tick value

   Attributes
     protected

8. #### def clone (): AnyRef

   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws()

9. #### def eq (arg0: AnyRef): Boolean

   Attributes
     final
   Definition Classes
     AnyRef

10. #### def equals (arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

11. #### def finalize (): Unit

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()

12. #### def getClass (): java.lang.Class[_]

    Attributes
      final
    Definition Classes
      AnyRef

13. #### def hashCode (): Int

    Definition Classes
      AnyRef → Any

14. #### def isConductorFrozen : Boolean

    Check if the clock has been frozen by any threads.

    Check if the clock has been frozen by any threads. (The only way a thread can freeze the clock is by calling withClockFrozen.)

    Attributes
      protected

15. #### def isInstanceOf [T0] : Boolean

    Attributes
      final
    Definition Classes
      Any

16. #### def ne (arg0: AnyRef): Boolean

    Attributes
      final
    Definition Classes
      AnyRef

17. #### def notify (): Unit

    Attributes
      final
    Definition Classes
      AnyRef

18. #### def notifyAll (): Unit

    Attributes
      final
    Definition Classes
      AnyRef

19. #### def synchronized [T0] (arg0: ⇒ T0): T0

    Attributes
      final
    Definition Classes
      AnyRef

20. #### def thread [T] (name: String)(f: ⇒ T): Thread

    Create a new thread that will execute the given function.

    Create a new thread that will execute the given function. If the test is started, then the thread will run the function immediately. If it is not yet started, the Thread will wait to run the function until all threads are up and ready to go.

    name

      the name of the thread

    f

      the function to be executed by the thread

    Attributes
      protected

21. #### def thread [T] (f: ⇒ T): Thread

    Create a new thread that will execute the given function.

    Create a new thread that will execute the given function. If the test is started, then the thread will run the function immediately. If it is not yet started, the Thread will wait to run the function until all threads are up and ready to go.

    f

      the function to be executed by the thread

    Attributes
      protected

22. #### def toString (): String

    Definition Classes
      AnyRef → Any

23. #### def wait (): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

24. #### def wait (arg0: Long, arg1: Int): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

25. #### def wait (arg0: Long): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

26. #### def waitForBeat (beat: Int): Unit

    Force the current thread to block until the thread clock reaches the specified value, at which point the current thread is unblocked.

    Force the current thread to block until the thread clock reaches the specified value, at which point the current thread is unblocked.

    Attributes
      protected

27. #### def whenFinished (fun: ⇒ Unit): Unit

    Register a function to be executed after the simulation has finished.

    Register a function to be executed after the simulation has finished.

    Attributes
      protected

28. #### def withConductorFrozen [T] (f: ⇒ T): Unit

    Run the passed function, ensuring the clock does not advance while the function is running (has not yet returned or thrown an exception).

    Run the passed function, ensuring the clock does not advance while the function is running (has not yet returned or thrown an exception).

    Attributes
      protected

29. #### def withFixture (test: NoArgTest): Unit

    Creates and initializes a private instance variable with a new Conductor, ensuring it is visible to any thread, invokes the passed test function, and invokes `conduct` on the `Conductor`, if it was not already invoked by the test.

    Creates and initializes a private instance variable with a new Conductor, ensuring it is visible to any thread, invokes the passed test function, and invokes `conduct` on the `Conductor`, if it was not already invoked by the test.

    test

      the no-arg test function to run with a fixture

    Definition Classes
      ConductorMethods → AbstractSuite

### Inherited from AbstractSuite

### Inherited from AnyRef

### Inherited from Any